# frozen_string_literal: true

require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/resource_interactions', type: :request do
  # This should return the minimal set of attributes required to create a valid
  # ResourceInteraction. As you add validations to ResourceInteraction, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) do
    FactoryBot.build(:resource_interaction).attributes
  end

  let(:invalid_attributes) do
    { subject_id: nil }
  end

  # This should return the minimal set of values that should be in the headers
  # in order to pass any filters (e.g. authentication) defined in
  # ResourceInteractionsController, or in your router and rack
  # middleware. Be sure to keep this updated too.
  let(:valid_headers) do
    {}
  end

  context 'with authenticated member' do
    include_context 'with authenticated member'

    describe 'GET /index' do
      it 'renders a successful response' do
        ResourceInteraction.create! valid_attributes
        get api_resource_interactions_url, headers: valid_headers, as: :json
        expect(response).to be_successful
      end
    end

    describe 'GET /show' do
      it 'renders a successful response' do
        resource_interaction = ResourceInteraction.create! valid_attributes
        get api_resource_interaction_url(resource_interaction), as: :json
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new ResourceInteraction' do
          expect do
            post api_resource_interactions_url, params: { resource_interaction: valid_attributes }, headers: valid_headers, as: :json
          end.to change(ResourceInteraction, :count).by(1)
        end

        it 'renders an successful response' do
          post api_resource_interactions_url, params: { resource_interaction: valid_attributes }, headers: valid_headers, as: :json
          expect(response).to have_http_status(:created)
        end

        it 'render the new resource interaction as JSON' do
          post api_resource_interactions_url, params: { resource_interaction: valid_attributes }, headers: valid_headers, as: :json
          expect(response.content_type).to match(a_string_including('application/json'))
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new ResourceInteraction' do
          expect do
            post api_resource_interactions_url, params: { resource_interaction: invalid_attributes }, as: :json
          end.not_to change(ResourceInteraction, :count)
        end

        it 'renders an error response' do
          post api_resource_interactions_url, params: { resource_interaction: invalid_attributes }, headers: valid_headers, as: :json
          expect(response).to have_http_status(:unprocessable_entity)
        end

        it 'render the error as JSON' do
          post api_resource_interactions_url, params: { resource_interaction: invalid_attributes }, headers: valid_headers, as: :json
          expect(response.content_type).to eq('application/json; charset=utf-8')
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) do
          { notes: 'New content' }
        end

        it 'updates the requested resource interaction' do
          resource_interaction = ResourceInteraction.create! valid_attributes
          patch api_resource_interaction_url(resource_interaction), params: { resource_interaction: new_attributes }, headers: valid_headers, as: :json
          resource_interaction.reload
          expect(resource_interaction.notes).to eq new_attributes[:notes]
        end

        it 'renders a successful response' do
          resource_interaction = ResourceInteraction.create! valid_attributes
          patch api_resource_interaction_url(resource_interaction), params: { resource_interaction: new_attributes }, headers: valid_headers, as: :json
          expect(response).to have_http_status(:ok)
        end

        it 'renders the resource interaction as JSON' do
          resource_interaction = ResourceInteraction.create! valid_attributes
          patch api_resource_interaction_url(resource_interaction), params: { resource_interaction: new_attributes }, headers: valid_headers, as: :json
          expect(response.content_type).to eq('application/json; charset=utf-8')
        end
      end

      context 'with invalid parameters' do
        it 'renders an error response' do
          resource_interaction = ResourceInteraction.create! valid_attributes
          patch api_resource_interaction_url(resource_interaction), params: { resource_interaction: invalid_attributes }, headers: valid_headers, as: :json
          expect(response).to have_http_status(:unprocessable_entity)
        end

        it 'render the error as JSON' do
          resource_interaction = ResourceInteraction.create! valid_attributes
          patch api_resource_interaction_url(resource_interaction), params: { resource_interaction: invalid_attributes }, headers: valid_headers, as: :json
          expect(response.content_type).to eq('application/json; charset=utf-8')
        end
      end
    end
  end

  context 'with authenticated admin' do
    include_context 'with authenticated admin'

    describe 'DELETE /destroy' do
      it 'destroys the requested resource_interaction' do
        resource_interaction = ResourceInteraction.create! valid_attributes
        expect do
          delete api_resource_interaction_url(resource_interaction), headers: valid_headers, as: :json
        end.to change(ResourceInteraction, :count).by(-1)
      end
    end
  end
end
